# Copyright (C) 2018 Adan Salazar <asalazargaribay@gmail.com>
#
#
# This file is part of GeoSentinel
#
#
# GeoSentinel is free software  you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# GeoSentinel is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with StereoVision.  If not, see <http://www.gnu.org/licenses/>.

"""
Command line arguments for collecting information about Sentinel data and products

"""


from argparse import ArgumentParser

SENTINEL_ARGUMENTS = ArgumentParser(add_help=False)

SENTINEL_ARGUMENTS.add_argument("init_date", help="initial date for dowloading period.")

SENTINEL_ARGUMENTS.add_argument("end_date", help="final date for dowloading period.")

SENTINEL_ARGUMENTS.add_argument("product_type", help="sentinel product type {SLC, GRD, IW }")

SENTINEL_ARGUMENTS.add_argument("plattform", help="sentinel-1 or sentinel-2")

SENTINEL_ARGUMENTS.add_argument("overlap", type=int, help="Percentage of overlapping between the polygon " 
                        "provided by the user and the polygon of the image")  


SENTINEL_ARGUMENTS.add_argument("output_folder", help="Folder to download Sentinel files ")

SENTINEL_ARGUMENTS.add_argument("username", help="User name platform to download Sentinel files")

SENTINEL_ARGUMENTS.add_argument("password", help="Password platform to download Sentinel files")

SENTINEL_ARGUMENTS.add_argument("input_file", help="file geojson local path")
    

SENTINEL_FIND_ARGUMENTS = ArgumentParser(add_help=False)

SENTINEL_FIND_ARGUMENTS.add_argument("folder", help="Folder to find Sentinel files ")

SENTINEL_FIND_ARGUMENTS.add_argument("plattform", help="Sentinel-1 or Sentinel-2")


SENTINEL_UNZIP_ARGUMENTS = ArgumentParser(add_help=False)

SENTINEL_UNZIP_ARGUMENTS.add_argument("folder", help="Folder to find Sentinel files")

SENTINEL_UNZIP_ARGUMENTS.add_argument("plattform", help="Sentinel-1 or Sentinel-2")

SENTINEL_UNZIP_ARGUMENTS.add_argument("product_type", help="sentinel product type {all, SM_SLC, SM_GRDF, SM_GRDH, SM_GRDM, IW_SLC, IW_GRDH, IW_GDRM, EW_SLC, EW_GRDH, EW_GRDM, WV_SLC, WV_GRDM, MSIL1C, OPER_PRD }")


SENTINEL_COMBINATION_ARGUMENTS = ArgumentParser(add_help=False)

SENTINEL_COMBINATION_ARGUMENTS.add_argument("folder", help="Folder to find Sentinel files .SAFE")

SENTINEL_COMBINATION_ARGUMENTS.add_argument("plattform", help="Sentinel-1 or Sentinel-2")

SENTINEL_COMBINATION_ARGUMENTS.add_argument("product_type", help="sentinel product type {all, SM_SLC, SM_GRDF, SM_GRDH, SM_GRDM, IW_SLC, IW_GRDH, IW_GDRM, EW_SLC, EW_GRDH, EW_GRDM, WV_SLC, WV_GRDM, MSIL1C, OPER_PRD }")

SENTINEL_COMBINATION_ARGUMENTS.add_argument("product_output_type", help="sentinel product type {RGB}")