# Copyright (C) 2018 Adan Salazar <asalazargaribay@gmail.com>
#
#
# This file is part of GeoSentinel
#
#
# GeoSentinel is free software  you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# GeoSentinel is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with StereoVision.  If not, see <http://www.gnu.org/licenses/>.

"""
Classes for having some Sentinel Products

Classes:

    * "SentinelData" - Class for Sentinel satellites configuration
    * "SentinelOneProducts" - A class that obtains Sentinel1 products
    
"""

class SentinelData(object):
    """ Class for Sentinel satellites configuration """
    
    def __init__(self):
        """
        Initialize Sentinel Data.
        """

        self.username = 'asalazarg'
        self.password='geo135asg'
        self.URL_Sentinel='https://scihub.copernicus.eu/dhus'
        
        self.init_date = None
        self.end_date = None
        
        self.product_type = None
        self.platform_name = None
        
        self.interest_footprint = None
        
        self.image_polygon = None
        
        self.plot_width = 7

        self.plot_height = 7
        
        self.intersection_th = 30
        
  
    
    
    
